/*
** Thierry Roncalli
** Introduction to Risk Parity & Budgeting
**
**> Page 349 (Exercise B.1.12)
**
*/

new;
library rpb,pgraph;

cls;

let mu    = 0.07 0.07 0.04 0.06 0.08; 
let sigma = 0.15 0.20 0.25 0.25 0.15;
r = 0.02;

let rho = 1.00 
          0.50 1.00
          0.30 0.20 1.00
          0.50 0.40 0.80 1.00
          0.40 0.50 0.70 0.50 1.00;
rho = xpnd(rho);
cov = rho .* sigma .* sigma';

call invpd(rho);

print;
print "=====================  Question 1.b  =======================================";

n = rows(cov);
A = ones(1,n); B = 1; e = ones(n,1);

Bounds = e .* (-2~2);
{x_star,u1,u2,u3,u4,retcode} = QProg(ones(n,1)/n,cov,zeros(n,1),A,B,0,0,0);

print ftosa(100*x_star,"%lf",5,3);

print;
print "=====================  Question 1.c  =======================================";

Bounds = e .* (0.00~0.40);
{x_tilde,lambda0,u2,lambda1,lambda2,retcode} = QProg(ones(n,1)/n,cov,zeros(n,1),A,B,0,0,Bounds);

Sigma_tilde = cov - (lambda1 + lambda1') + (lambda2 + lambda2');
call invpd(Sigma_tilde);
{x_bar,u1,u2,u3,u4,retcode} = QProg(ones(n,1)/n,Sigma_tilde,zeros(n,1),A,B,0,0,0);

results = x_star~x_tilde~x_bar;
print ftosa(100*results,"%lf",5,3);

_sigma_tilde = sqrt(diag(Sigma_tilde));
rho_tilde = Sigma_tilde ./ _sigma_tilde ./ _sigma_tilde';

print ftosa(100*(x_tilde~lambda1~lambda2),"%lf",5,3)$~ftosa(100*(_sigma_tilde~rho_tilde),"%lf",5,2);
print ftosa(100*lambda0,"%lf",3,3);


print;
print "=====================  Question 1.d  =======================================";

vol1 = sqrt(x_tilde'*cov*x_tilde);
mr1 = (lambda0 + lambda1 - lambda2)/vol1;

print ftosa(100*vol1,"%lf",3,3);
print ftosa(100*lambda0,"%lf",3,3);
print ftosa(100*(lambda1~lambda2),"%lf",3,3);
print ftosa(100*(mr1~(cov*x_tilde)/vol1),"%lf",3,2);

Bounds = e .* (0.03~0.40);
{x_tilde2,lambda0,u2,lambda1,lambda2,retcode} = QProg(ones(n,1)/n,cov,zeros(n,1),A,B,0,0,Bounds);

Sigma_tilde2 = cov - (lambda1 + lambda1') + (lambda2 + lambda2');
call invpd(Sigma_tilde2);
{x_bar2,u1,u2,u3,u4,retcode} = QProg(ones(n,1)/n,Sigma_tilde2,zeros(n,1),A,B,0,0,0);

print ftosa(100*(x_tilde2~x_bar2),"%lf",5,3);

vol2 = sqrt(x_tilde2'*cov*x_tilde2);
vol2_approx = vol1 + mr1'(x_tilde2-x_tilde);

print;
print /flush ftosa(100*(vol1~vol2~vol2_approx),"%lf",3,2);

print;
print "=====================  Question 2.c  =======================================";

C = eye(n)|-eye(n);
D = 0.10*ones(n,1)|-0.50*ones(n,1);

{x_tilde,lambda0,lambda,lambda1,lambda2,retcode} = QProg(ones(n,1)/n,cov,zeros(n,1),A,B,C,D,0);

e = ones(n,1);

Sigma_tilde = cov - (C'lambda*e' + e*lambda'C);
call invpd(Sigma_tilde);
{x_bar,lambda0_tilde,lambda_tilde,u3,u4,retcode} = QProg(ones(n,1)/n,Sigma_tilde,zeros(n,1),A,B,0,0,0);

results = x_star~x_tilde~x_bar;
print ftosa(100*results,"%lf",5,3);
print;

print ftosa(100*(lambda0-lambda'D~lambda0_tilde),"%lf",3,5);

print;
print "=====================  Question 2.d  =======================================";

C = -1~-1~0~0~0 |
     0~0~0~1~0;
D = -0.40|0.10;

{x_tilde,lambda0,lambda,u3,u4,retcode} = QProg(ones(n,1)/n,cov,zeros(n,1),A,B,C,D,0);

Sigma_tilde = cov - (C'lambda + lambda'C);
call invpd(Sigma_tilde);
{x_bar,u1,u2,u3,u4,retcode} = QProg(ones(n,1)/n,Sigma_tilde,zeros(n,1),A,B,0,0,0);

results = x_star~x_tilde~x_bar;
print ftosa(100*results,"%lf",5,3);

print ftosa(100*lambda,"%lf",5,3);

_sigma_tilde = sqrt(diag(Sigma_tilde));
rho_tilde = Sigma_tilde ./ _sigma_tilde ./ _sigma_tilde';

print ftosa(100*_sigma_tilde,"%lf",5,2);
print ftosa(100*rho_tilde,"%lf",5,2);

print;
print "=====================  Question 3.b  =======================================";

C = -1~-1~0~0~0 |
     0~0~0~1~-1 |
     0~0~0~-1~1 ;
D = -0.50|0.00|0.00;

{x_tilde,lambda0,lambda,u3,u4,retcode} = QProg(ones(n,1)/n,cov,zeros(n,1),A,B,C,D,0);

Sigma_tilde = cov - (C'lambda + lambda'C);
call invpd(Sigma_tilde);
{x_bar,u1,u2,u3,u4,retcode} = QProg(ones(n,1)/n,Sigma_tilde,zeros(n,1),A,B,0,0,0);

results = x_star~x_tilde~x_bar;
print ftosa(100*results,"%lf",5,3);

print ftosa(100*lambda,"%lf",5,3);

_sigma_tilde = sqrt(diag(Sigma_tilde));
rho_tilde = Sigma_tilde ./ _sigma_tilde ./ _sigma_tilde';

print ftosa(100*_sigma_tilde,"%lf",5,2);
print ftosa(100*rho_tilde,"%lf",5,2);

print;
print "=====================  Question 2.b  =======================================";

let sigma = 0.15 0.15 0.05;
let rho = 1.00 
          0.50 1.00
          0.20 0.20 1.00;
rho = xpnd(rho);
cov = rho .* sigma .* sigma';
n = rows(cov);
        
Bounds = (0.20~0.80) .* ones(3,1);
{x_tilde,lambda0,u2,lambda1,lambda2,retcode} = QProg(ones(n,1)/n,cov,zeros(n,1),ones(1,n),1,0,0,Bounds);
var_tilde = x_tilde'cov*x_tilde;

Sigma_tilde = cov - (lambda1 + lambda1') + (lambda2 + lambda2');

{x_bar,u1,u2,u3,u4,retcode} = QProg(ones(n,1)/n,Sigma_tilde,zeros(n,1),ones(1,n),1,0,0,0);
var_bar = x_bar'Sigma_tilde*x_bar;

x_breve = inv(Sigma_tilde)*ones(n,1);
x_breve = x_breve / sumc(x_breve);
var_breve = x_breve'Sigma_tilde*x_breve;

results = x_tilde~x_bar~x_breve;
print ftosa(100*results,"%lf",5,3);

results = var_tilde~var_bar~var_breve;
print ftosa(10000*results,"%lf",5,3);

{va,ve} = eigv(Sigma_tilde);

proc f(x);
  x[n] = 1.0 - sumc(x[1:n-1]);
  retp(x'*sigma_tilde*x);
endp;

{x_check,f_check,grd,retcode} = Qnewton(&f,ones(n,1)/n);
x_check[n] = 1.0 - sumc(x_check[1:n-1]);

results = x_tilde~x_bar~x_breve~x_check;
print ftosa(100*results,"%lf",5,3);

oldtrap = trapchk(1);
trap 1,1;
test = invpd(Sigma_tilde);
trap oldtrap,1;
if scalerr(test);
  print "Sigma Tilde is not positive semi-definite";
else;
  print test;
endif;