/*
** Thierry Roncalli
** Introduction to Risk Parity & Budgeting
**
**> Page 339 (Exercise B.1.3)
**
*/

new;
library rpb,pgraph;

cls;

rndseed 123;

n = 4;

r = 0.05;
mu = r + rndu(n,1)*0.10;
sigma = rndu(n,1) * 0.30;
sh = (mu - r)./sigma;

print;
print "----------------------------------";
print ftosa(mu~sigma~sh,"%lf",3,3);

rho = 0;
rho = diagrv(rho*ones(n,n),1);
cov = rho .* sigma .* sigma';
x = ones(n,1)/n;

print;
print "=====================  Question 2.b  =======================================";

sh1 = (x'mu - r)/sqrt(x'*cov*x);
sh2 = sumc(mu - r)/sqrt(sumc(sigma^2));
w = sigma/sqrt(sumc(sigma^2));
sh3 = w'sh;

print ftosa(sh1~sh2~sh3,"%lf",3,4);

print;
print "=====================  Question 2.d  =======================================";

let sigma = 0.20 0.20 0.30 0.10 0.30;
let sh =    0.40 0.35 0.30 0.70 0.40;
w1 = sigma/sqrt(sumc(sigma^2));
sh1 = w1'sh;

let sigma = 0.15 0.15 0.20 0.10 0.50;
let sh =    0.10 0.15 0.05 0.05 0.90;
w2 = sigma/sqrt(sumc(sigma^2));
sh2 = w2'sh;

print ftosa(100*((w1'~sumc(w1)~sh1)|(w2'~sumc(w2)~sh2)),"%lf",3,1);

n = 10;

r = 0.05;
mu = r + rndu(n,1) * 0.10;
sigma = ones(n,1) * 0.30;
sh = (mu - r)./sigma;

print;
print "----------------------------------";
print ftosa(mu~sigma~sh,"%lf",3,3);

print;
print "=====================  Question 3.b  =======================================";

rho = 0.5;
cor = diagrv(rho*ones(n,n),1);
cov = cor .* sigma .* sigma';
x = ones(n,1)/n;

vol1 = sqrt(x'*cov*x);
sh1 = x'(mu - r)/vol1;
vol2 = sigma[1]*sqrt(rho + (1 - rho)/n);
sh2 = (sigma[1]*sumc(sh)/n)/vol2;

w = (1/sqrt(rho + (1 - rho)/n));
sh3 = w*meanc(sh);

print ftosa(sh1~sh2~sh3,"%lf",3,4);

print;
print "=====================  Question 3.c  =======================================";

rho = 0.50;
w = 1.25;
n = (w^2)*(1 - rho)/(1 - rho * w^2);

print ftosa(n,"%lf",3,2);

print;
print "=====================  Question 3.d  =======================================";

n = 1000;
rho = 0.80;
w1 = (1/sqrt(rho + (1 - rho)/n));
w2 = 1/sqrt(rho);

print ftosa(w1~w2,"%lf",3,2);

print;
print "=====================  Question 4.b  =======================================";

let rho = 0.00 0.10 0.20 0.30 0.50 0.75 0.90;
rho = rho';
let n =   10 20 30 50;
w = (1./sqrt(rho + (1 - rho)./n));
w = w|1./sqrt(rho);

Results = rho|w;

print ftosa(Results,"%lf",3,2);
