/*
** Thierry Roncalli
** Introduction to Risk Parity & Budgeting
**
**> Page 362 (Exercise B.3.1)
**
*/

new;
library rpb,pgraph;

cls;

__output = 0;

/*
**> Question 1
**
*/

let mu =    0.06 0.10 0.06 0.08 0.12;
r = 0.02;

let sigma = 0.10 0.20 0.15 0.25 0.30;
let rho =   1.0
            0.6 1.0
            0.4 0.5 1.0
            0.3 0.3 0.2  1.0
            0.2 0.1 0.1 -0.5 1.0;

rho = xpnd(rho);
call invpd(rho);

cov = rho .* sigma .* sigma';
n = rows(cov);

Bounds = -10~10;  

print;
print "=====================  Question 1.a  =======================================";

x = invpd(cov)*(mu-r);
x = x / sumc(x);

{vol,mr,rc,prc} = Compute_Risk_Contribution(x,cov);
results = (x~mr~rc~prc)|(error(0)~error(0)~vol~error(0));

print ftosa(100*results,"%lf",3,2);

x_mvo = x;

print;
print "=====================  Question 1.b  =======================================";

x = ones(n,1)/n;
{vol,mr,rc,prc} = Compute_Risk_Contribution(x,cov);
results = (x~mr~rc~prc)|(error(0)~error(0)~vol~error(0));

print ftosa(100*results,"%lf",3,2);

x_ew = x;

print;
print "=====================  Question 1.c  =======================================";

{x,vol,retcode} = Compute_MV_Portfolio(cov,ones(1,n),1,0,0,Bounds .* ones(n,1));
{vol,mr,rc,prc} = Compute_Risk_Contribution(x,cov);
results = (x~mr~rc~prc)|(error(0)~error(0)~vol~error(0));

print ftosa(100*results,"%lf",3,2);

x_mv = x;

print;
print "=====================  Question 1.d  =======================================";

{x,vol,mr,rc,prc} = Compute_MDP_Portfolio(0,cov,bounds);
results = (x~mr~rc~prc)|(error(0)~error(0)~vol~error(0));

print ftosa(100*results,"%lf",3,2);

x_mdp = x;

print;
print "=====================  Question 1.e  =======================================";

{x,vol,mr,rc,prc} = Compute_ERC_Portfolio(0,cov);
results = (x~mr~rc~prc)|(error(0)~error(0)~vol~error(0));

print ftosa(100*results,"%lf",3,2);

x_erc = x;

print;
print "=====================  Question 1.f  =======================================";

all_x = x_mvo~x_ew~x_mv~x_mdp~x_erc;
b = x_mvo;

Results = zeros(6,5);

i = 1;
do until i > 5;
  x = all_x[.,i];
  mu_x = mu'x;
  vol_x = sqrt(x'cov*x);
  SR_x = (mu_x - r)/vol_x;
  TE_x = sqrt( (x-b)'cov*(x-b));
  beta_x = (x'*cov*b)/(b'cov*b);
  rho_x = (x'*cov*b)/sqrt(b'cov*b)/sqrt(x'cov*x);

  Results[.,i] = mu_x|vol_x|SR_x|TE_x|beta_x|rho_x;
  i = i + 1;
endo;

print ftosa(100*results,"%lf",3,2);

/*
**> Question 2
**
*/

Bounds = 0~1;  

print;
print "=====================  Question 2.a  =======================================";

x = invpd(cov)*(mu-r);
x = x / sumc(x);

{vol,mr,rc,prc} = Compute_Risk_Contribution(x,cov);
results = (x~mr~rc~prc)|(error(0)~error(0)~vol~error(0));

print ftosa(100*results,"%lf",3,2);

x_mvo = x;

print;
print "=====================  Question 2.b  =======================================";

x = ones(n,1)/n;
{vol,mr,rc,prc} = Compute_Risk_Contribution(x,cov);
results = (x~mr~rc~prc)|(error(0)~error(0)~vol~error(0));

print ftosa(100*results,"%lf",3,2);

x_ew = x;

print;
print "=====================  Question 2.c  =======================================";

{x,vol,retcode} = Compute_MV_Portfolio(cov,ones(1,n),1,0,0,Bounds .* ones(n,1));
{vol,mr,rc,prc} = Compute_Risk_Contribution(x,cov);
results = (x~mr~rc~prc)|(error(0)~error(0)~vol~error(0));

print ftosa(100*results,"%lf",3,2);

x_mv = x;

print;
print "=====================  Question 2.d  =======================================";

{x,vol,mr,rc,prc} = Compute_MDP_Portfolio(0,cov,bounds);
results = (x~mr~rc~prc)|(error(0)~error(0)~vol~error(0));

print ftosa(100*results,"%lf",3,2);

x_mdp = x;

print;
print "=====================  Question 2.e  =======================================";

{x,vol,mr,rc,prc} = Compute_ERC_Portfolio(0,cov);
results = (x~mr~rc~prc)|(error(0)~error(0)~vol~error(0));

print ftosa(100*results,"%lf",3,2);

x_erc = x;

print;
print "=====================  Question 2.f  =======================================";

all_x = x_mvo~x_ew~x_mv~x_mdp~x_erc;
b = x_mvo;

Results = zeros(6,5);

i = 1;
do until i > 5;
  x = all_x[.,i];
  mu_x = mu'x;
  vol_x = sqrt(x'cov*x);
  SR_x = (mu_x - r)/vol_x;
  TE_x = sqrt( (x-b)'cov*(x-b));
  beta_x = (x'*cov*b)/(b'cov*b);
  rho_x = (x'*cov*b)/sqrt(b'cov*b)/sqrt(x'cov*x);

  Results[.,i] = mu_x|vol_x|SR_x|TE_x|beta_x|rho_x;
  i = i + 1;
endo;

print ftosa(100*results,"%lf",3,2);





