/*
** Thierry Roncalli
** Introduction to Risk Parity & Budgeting
**
**> Page 365 (Exercise B.3.4)
**
*/

new;
library rpb,pgraph;

cls;

__output = 0;

/*
**> Question 3
**
*/

print;
print "=====================  Question 3.a  =======================================";

n = 4;
let _beta        = 0.80 0.90 1.10 1.20;
let sigma_tilde = 0.02 0.05 0.15 0.15;

sigma_m = 0.20;

D = diagrv(zeros(n,n),sigma_tilde^2);
cov = (sigma_m^2)*_beta*_beta' + D;

sigma = sqrt(_beta^2*sigma_m^2 + sigma_tilde^2);
rho = _beta .* sigma_m ./ sigma;

rho_star = (1 + sumc( (rho^2)./(1-rho^2) ) ) / sumc( rho ./ (1 - rho^2) );

x = sigma ./ (sigma_tilde^2) .* (1 - rho/rho_star);
x1 = x / sumc(x);

{x2,vol2,mr,rc,prc} = Compute_MDP_Portfolio(0,cov,-5~5);
{x3,vol3,retcode} = Compute_MV_Portfolio(cov,ones(1,n),1,0,0,-5~5);

{x4,vol4,mr,rc,prc} = Compute_MDP_Portfolio(0,cov,0~1);
{x5,vol5,retcode} = Compute_MV_Portfolio(cov,ones(1,n),1,0,0,0~1);

print ftosa(100*(x1~x2),"%lf",3,2);

Results = _beta~100*(rho~x2~x3~x4~x5)|100*(error(0)~error(0)~vol2~vol3~vol4~vol5);
print ftosa(Results,"%lf",3,2);

print ftosa(100*rho_star,"rho* = %lf",3,2);

print;
print "=====================  Question 3.b  =======================================";

let rho = 1.0
          0.9   1.0
          0.8   0.8   1.0
          0.0   0.0  -0.25  1.0;
let sigma = 0.10 0.10 0.50 0.50;
rho = xpnd(rho);
call invpd(rho);
cov = rho .* sigma .* sigma';

{x2,vol2,mr,rc,prc} = Compute_MDP_Portfolio(0,cov,-5~5);
{x3,vol3,retcode} = Compute_MV_Portfolio(cov,ones(1,n),1,0,0,-5~5);

{x4,vol4,mr,rc,prc} = Compute_MDP_Portfolio(0,cov,0~1);
{x5,vol5,retcode} = Compute_MV_Portfolio(cov,ones(1,n),1,0,0,0~1);

Results = 100*(x2~x3~x4~x5)|100*(vol2~vol3~vol4~vol5);
print ftosa(Results,"%lf",3,2);



