/*
** Thierry Roncalli
** Introduction to Risk Parity & Budgeting
**
**> Page 24
**
*/

new;
library rpb,pgraph;

cls;

let mu =    0.05 0.06 0.08 0.06;
let sigma = 0.15 0.20 0.25 0.30;
n = rows(sigma);
let rho =   1.00 
            0.10   1.00
            0.40   0.70   1.00
            0.50   0.40   0.80 1.00;
rho = xpnd(rho);
call invpd(rho);

cov = rho .* sigma .* sigma';
s0 = 0.25;
r = 0.03;
let x0 = 0.40 0.30 0.20 0.10;

sigma0 = sqrt(x0'cov*x0);
phi0 = s0/sigma0;
print ftosa(100*sigma0,"sigma0 = %lf",3,2);
print ftosa(phi0,"phi0 = %lf",3,2);
print "--------------------------------------";

mu_tilde = r + s0 .* (cov * x0)/sigma0;
print ftosa(100*mu_tilde,"%lf",3,2);
print "--------------------------------------";

mu_tilde = r + phi0 .* (cov * x0);
print ftosa(100*mu_tilde,"%lf",3,2);
