/*
** Thierry Roncalli
** Introduction to Risk Parity & Budgeting
**
**> Pages 144 & 145 (Tables 2.31 and 2.32)
**
*/

new;

#define use_co 1

#ifdef use_co
  library rpb,pgraph,co;
#else
  library rpb,pgraph;
#endif

cls;

Let A[4,3] = 0.9    0.0     0.5
             1.1    0.5     0.0
             1.2    0.3     0.2
             0.8    0.1     0.7;

let vol_F = 0.20 0.10 0.10;
Omega = diagrv(eye(3),vol_F^2);
let sigma_A = 0.10 0.15 0.10 0.15;
D = diagrv(eye(4),sigma_A^2);

Sigma = A*Omega*A' + D;
vol_A = sqrt(diag(Sigma));
rho_A = Sigma ./ vol_A ./ vol_A';

n = rows(A);
m = cols(A);

print ftosa(100*vol_A,"%lf",3,2);
print ftosa(100*rho_A,"%lf",3,2);

indx = seqa(1,1,4);
let b = 0.49 0.25 0.25 0.01;

_rpb_factor_bounds = -1;

{x,y,f_mr,f_rc,f_prc} = Compute_RB_Factor(0,Sigma,A,Omega,D,b,indx,1); 
{vol,mr,rc,prc} = Compute_Risk_Contribution(x,Sigma);

cls;

print ftos(100*vol,"vol = %lf",3,2);
print ftosa(100*(y~f_mr~f_rc~f_prc),"%lf",3,2);

print "--------------------------------------------------------------------------------";

print ftos(100*vol,"vol = %lf",3,2);
print ftosa(100*(x~mr~rc~prc),"%lf",3,2);