/*
** Thierry Roncalli
** Introduction to Risk Parity & Budgeting
**
**> Page 176 (Example 28)
**
*/

new;
library rpb,pgraph;

cls;

let sigma = 0.10 0.20 0.30 0.40;
sigma = rev(sigma);
let rho = 1.00
          0.80 1.00
          0.00 0.00 1.00
          0.00 0.00 -0.50 1.00;
rho = xpnd(rho);
call invpd(rho);

cov = sigma .* sigma' .* rho;
n = rows(cov);

__output = 0;

Results = miss(zeros(8,4*3),0);

i = 1;
do until i > 4;
  x = ones(n,1)/4;
  if i == 1;
   {vol,mr,rc,prc} = Compute_Risk_Contribution(x,cov);
  elseif i == 2;
    {x,vol,retcode} = Compute_MV_Portfolio(cov,ones(1,n),1,0,0,ones(n,1).*(0~1));
    {vol,mr,rc,prc} = Compute_Risk_Contribution(x,cov);
  elseif i == 3;
    {x,vol,mr,rc,prc} = Compute_MDP_Portfolio(x,cov,0);
  elseif i == 4;
    {x,vol,mr,rc,prc} = Compute_ERC_Portfolio(x,cov);
  endif;

  p = x;
  {H,Hstar_weights,Neff} = Herfindahl_Index(p);
  p = prc;
  {H,Hstar_rc,Neff} = Herfindahl_Index(p);
  DR = Diversification_Ratio(x,cov);
  
  print "------------------------------------------------------------------------";
  print ftosa(vol,"%lf",3,3);
  print ftosa(x~mr~rc~(rc/vol)*100,"%lf",3,3);

  Results[1:4,3*(i-1)+1:3*i] = 100*(x~mr~(x.*mr));

  Results[5,3*i] = 100*Hstar_weights;
  Results[6,3*i] = 100*vol;
  Results[7,3*i] = DR;
  Results[8,3*i] = 100*Hstar_rc;

  i = i + 1;
endo;

msym " ";
let fmt[1,3] = "%lf" 8 2;
print;
print "------------------------------------------------------------------------";
call printfm(results,1,fmt);
print;
print "------------------------------------------------------------------------";
call printfm(results[.,1 3 4 6 7 9 10 12],1,fmt);
