/*
** Thierry Roncalli
** Introduction to Risk Parity & Budgeting
**
**> Page 201 (Example 34)
**
*/

new;
library rpb,pgraph;
rpbSet;

cls;

_Bond_Continuous_Time = 1;

declare matrix lambda;
let params = 0.05 -0.05 0.06 10;
fn Survival_Function(t) = exp(-lambda*t);
fn Density_Function(t) = lambda * exp(-lambda*t);
fn YieldCurve_Function(t) = NelsonSiegel_Spot_Rate(params,t);

Coupon = 4.5;
Maturity = 10;
Notional = 100;
t = seqa(1,1,Maturity);
Ct = Coupon * ones(Maturity,1);
Recovery_Rate = 0.40;

lambda = 0.00;
P1 = Risky_Bond_Price(t,Ct,Notional,Maturity,Recovery_Rate,&YieldCurve_Function,&Survival_Function,&Density_Function);

lambda = 0.02;
P2 = Risky_Bond_Price(t,Ct,Notional,Maturity,Recovery_Rate,&YieldCurve_Function,&Survival_Function,&Density_Function);

lambda = 0.10;
P3 = Risky_Bond_Price(t,Ct,Notional,Maturity,Recovery_Rate,&YieldCurve_Function,&Survival_Function,&Density_Function);

print "Bond Price = ";
print ftosa((P1|P2|P3),"%lf",3,2);





